{
  File:       XTrakBar.pas
  Function:   TTrackBar which can hide the selection range.
  Language:   Delphi 2.0
  Author:     Rudolph Velthuis
  Copyright:  (c) 1997 drs. Rudolph Velthuis
  Disclaimer: This code is freeware. All rights are reserved.
              This code is provided as is, expressly without a warranty of any kind.
              You use it at your own risk.
              If you use this code, please credit me.
}

unit XTrakBar;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, CommCtrl;

type
  TExTrackBar = class(TTrackBar)
  private
    FShowSelRange: Boolean;
    procedure SetShowSelRange(Value: Boolean);
  protected
    procedure CreateParams(var Params: TCreateParams); override;
  public
    constructor Create(AOwner: TComponent); override;
  published
    property ShowSelRange: Boolean read FShowSelRange write SetShowSelRange default True;
  end;

procedure Register;

implementation

constructor TExTrackBar.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FShowSelRange := True;
end;

procedure TExTrackBar.SetShowSelRange(Value: Boolean);
begin
  if Value <> FShowSelRange then
  begin
    FShowSelRange := Value;
    RecreateWnd;
  end;
end;

procedure TExTrackBar.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);
  if not FShowSelRange then
    Params.Style := Params.Style and not (TBS_ENABLESELRANGE);
end;

procedure Register;
begin
  RegisterComponents('Samples', [TExTrackBar]);
end;

end.
